#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    FreqMem=0;
    dig_key = 0;

    timer_ticket = new QTimer;
    timer_device_control = new QTimer;


    //Связываем сигнал переполнения таймера со слотом
    QObject::connect(timer_ticket,SIGNAL(timeout()), this, SLOT(timer_ticket_overflow()));
    QObject::connect(timer_device_control,SIGNAL(timeout()), this, SLOT(timer_dev_ctr_overflow()));
    timer_device_control->start(1000);

    ; // График

    progressBar.setValue(0);
    progressBar.setMaximum(2000);
    progressBar.setVisible(false);
    /// Строка статуса

    ui->statusBar->addWidget(&progressBar);
    ui->statusBar->addWidget(&statusBarFreq);
    ui->statusBar->addWidget(&statusBarText);


    // DDS
    data.setFreqStart(ui->spinBoxFreqStart->value());
    data.setFreqStop(ui->spinBoxFreqStop->value());
    data.setFreqStep(ui->spinBoxFreqStep->value());


    ui->checkBoxC1->setStyleSheet("QCheckBox { color: red }");
    ui->checkBoxC2->setStyleSheet("QCheckBox { color: grean }");
    ui->checkBoxC3->setStyleSheet("QCheckBox { color: blue }");
    ui->checkBoxC4->setStyleSheet("QCheckBox { color: black }");

    ui->hS_Chanel0->setStyleSheet("QSlider { color: red }");
    ui->hS_Chanel0->setStyleSheet("QSlider { color: grean }");
    ui->hS_Chanel0->setStyleSheet("QSlider { color: blue }");
    ui->hS_Chanel0->setStyleSheet("QSlider { color: black }");


    thread_usb_data = new QThread;

    /// Thread
    QObject::connect(thread_usb_data,SIGNAL(started()),&data,SLOT(run()));
    QObject::connect(&data,SIGNAL(finished()),thread_usb_data,SLOT(terminate()));

    data.moveToThread(thread_usb_data);

    /// Запускаем поток от USB
    thread_usb_data->start();
    ui->lcdNumber->display((int)data.getFreqGen());
    ui->pushButton->setDisabled(true);
}

MainWindow::~MainWindow()
{
    data.stop();
    delete ui;
}


void MainWindow::replaceGraphTickX(){
   if (!ui->pushButton->isChecked()) return;

    // генерируем данные
    double step = ((double)(data.getFreqStop() - data.getFreqStart())) / 2000;
    double start = data.getFreqStart();

    for (int i=0; i<2000; ++i)
    {
      data.setX(i,start);
        start+=step;
    }
}

void MainWindow::on_pushButton_clicked()
{

    data.setTimer_tick(0);
    if (ui->pushButton->isChecked()){

        //ui->checkBoxC1->setEnabled(false);
        //ui->checkBoxC2->setEnabled(false);
        //ui->checkBoxC3->setEnabled(false);
        //ui->checkBoxC4->setEnabled(false);

        data.setChanelEnable1(ui->checkBoxC1->isChecked());
        data.setChanelEnable2(ui->checkBoxC2->isChecked());
        data.setChanelEnable3(ui->checkBoxC3->isChecked());
        data.setChanelEnable4(ui->checkBoxC4->isChecked());

        progressBar.setVisible(true);
        statusBarFreq.setVisible(true);
        /// Изменяем интерфейс
        ui->pushButton->setText("STOP");
        // Отключаем настройки частоты
        //ui->spinBoxFreqStart->setDisabled(true);
        //ui->spinBoxFreqStop->setDisabled(true);
        //ui->spinBoxFreqStep->setDisabled(true);
        ui->checkBoxScaled->setDisabled(true);

            //graf_create = true;
            // генерируем данные
            double step = ((double)(data.getFreqStop() - data.getFreqStart())) / 2000;
            double start = data.getFreqStart();

            for (int i=0; i<2000; ++i)
            {
              data.setX(i,start);
                start+=step;
              data.setY1(i,0);
              data.setY2(i,0);
              data.setY3(i,0);
              data.setY4(i,0);
            }
            // создаем график и добавляем данные:
           ui->widgetCustomPlot->addGraph();
           ui->widgetCustomPlot->addGraph();
           ui->widgetCustomPlot->addGraph();
           ui->widgetCustomPlot->addGraph();

            ui->widgetCustomPlot->graph(0)->setData(*data.getX(), *data.getY1());
            ui->widgetCustomPlot->graph(1)->setData(*data.getX(), *data.getY2());
            ui->widgetCustomPlot->graph(2)->setData(*data.getX(), *data.getY3());
            ui->widgetCustomPlot->graph(3)->setData(*data.getX(), *data.getY4());
            ui->widgetCustomPlot->graph(0)->setPen(QColor(255, 0, 0, 255));
            ui->widgetCustomPlot->graph(1)->setPen(QColor(0, 255, 0,255));
            ui->widgetCustomPlot->graph(2)->setPen(QColor(0, 0, 255,255));
            ui->widgetCustomPlot->graph(3)->setPen(QColor(0, 0, 0,255));

            // задаем имена осей координат
            ui->widgetCustomPlot->xAxis->setLabel("x");
            ui->widgetCustomPlot->yAxis->setLabel("y");
            // задаем размеры осей
            ui->widgetCustomPlot->xAxis->setRange(data.getFreqStart(), data.getFreqStop());
            ui->widgetCustomPlot->yAxis->setRange(0, 1023);

//// Сетка по X
 /*           QVector<double> Ticks;  // вектор с шагом в 30 градусов
            int i = 0;
            while(i<=1000) {
                Ticks << i;
                i+=20;
            }
            ui->widget->xAxis->setAutoTicks(false); // выключаем автоматические отсчеты
            ui->widget->xAxis->setTickVector(Ticks);  // задаем созданный нами вектор
*/

/// Сетка по Y
            QVector<QString> Labels;
            Labels << "0" << QString::fromUtf8("0.5") << QString::fromUtf8("1")
                   << QString::fromUtf8("1.5") << QString::fromUtf8("2")

                      ;

            //ui->widget->yAxis->setAutoTickLabels(false);
            //ui->widget->yAxis->setTickVectorLabels(Labels);

         //ui->widget->graph(1)->rescaleAxes(true);
        ui->widgetCustomPlot->axisRect()->setRangeZoom(ui->widgetCustomPlot->xAxis->orientation());
         ui->widgetCustomPlot->setInteractions(QCP::iRangeDrag | QCP::iRangeZoom | QCP::iSelectPlottables);
         ui->widgetCustomPlot->replot();

        //Задаем время срабатывания таймера (в мс)
        timer_ticket->start(data.getSpeed_diff());

        data.setWork_pause(PAUSE_NO);

    }else{
        //Задаем время срабатывания таймера (в мс)
        timer_ticket->stop();
        ui->pushButton->setText("START");
        ui->spinBoxFreqStart->setDisabled(false);
        ui->spinBoxFreqStop->setDisabled(false);
        ui->spinBoxFreqStep->setDisabled(false);
        ui->checkBoxScaled->setDisabled(false);

        //// Убираем данные
        ///
        ui->widgetCustomPlot->removeGraph(3);
        ui->widgetCustomPlot->removeGraph(2);
        ui->widgetCustomPlot->removeGraph(1);
        ui->widgetCustomPlot->removeGraph(0);
        progressBar.setVisible(false);
        statusBarFreq.setVisible(false);
        ui->checkBoxC1->setEnabled(true);
        ui->checkBoxC2->setEnabled(true);
        ui->checkBoxC3->setEnabled(true);
        ui->checkBoxC4->setEnabled(true);

        data.setWork_pause(PAUSE);

    }

}

void MainWindow::timer_ticket_overflow()
{

    if (data.getChanelEnable1()) ui->widgetCustomPlot->graph(0)->setData(*data.getX(), *data.getY1());
    if (data.getChanelEnable2())ui->widgetCustomPlot->graph(1)->setData(*data.getX(), *data.getY2());
    if (data.getChanelEnable3())ui->widgetCustomPlot->graph(2)->setData(*data.getX(), *data.getY3());
    if (data.getChanelEnable4())ui->widgetCustomPlot->graph(3)->setData(*data.getX(), *data.getY4());

    if (ui->checkBoxScaled->isChecked()){
         ui->widgetCustomPlot->rescaleAxes();      // Масштабируем график по данным
       };

    progressBar.setValue(data.getTimer_tick());
    statusBarFreq.setText("  Freq kHz: "+QString::number(data.getStep_dds()/1000) + "  ");

    ui->widgetCustomPlot->replot();

    if (ui->horizontalSlider_SpeedDiff->value() != data.getSpeed_diff()){
     data.setSpeed_diff(ui->horizontalSlider_SpeedDiff->value());
    timer_ticket->start(data.getSpeed_diff());
 }

}

void MainWindow::timer_dev_ctr_overflow(){

    if (!data.connect()){
        statusBarText.setText(data.getError_usb());
        ui->cB_device_enable->setChecked(false);

        if (ui->pushButton->isChecked()){
            ui->pushButton->setChecked(false);
            on_pushButton_clicked();
        }
        ui->pushButton->setDisabled(true);
    }else{
        ui->cB_device_enable->setChecked(true);
        statusBarText.setText("Connect Device");
        ui->pushButton->setDisabled(false);
    }

}


void MainWindow::on_spinBoxFreqStart_editingFinished()
{
    data.setFreqStart(ui->spinBoxFreqStart->value());
    data.setFreqStop(ui->spinBoxFreqStop->value());
    data.setFreqStep(ui->spinBoxFreqStep->value());

    replaceGraphTickX();
/*
    if (FreqStop < FreqStart)
    {
        FreqStop = FreqStart;
        ui->spinBoxFreqStop->setValue(FreqStop);
    }

    if (FreqStep > 0){
    if ((FreqStop - FreqStart)/FreqStep > 1000){
        int step = (FreqStop - FreqStart) / 1000 + 1;
        ui->spinBoxFreqStep->setValue(step);
        FreqStep = step;
    }}else{
        FreqStop = FreqStart;
        ui->spinBoxFreqStart->setValue(FreqStart);
        ui->spinBoxFreqStop->setValue(FreqStop);
    }
*/

}

void MainWindow::on_spinBoxFreqStop_editingFinished()
{
    data.setFreqStart(ui->spinBoxFreqStart->value());
    data.setFreqStop(ui->spinBoxFreqStop->value());
    data.setFreqStep(ui->spinBoxFreqStep->value());

    replaceGraphTickX();
    /*

    if (FreqStop < FreqStart)
    {
        FreqStart = FreqStop;
        ui->spinBoxFreqStart->setValue(FreqStart);
    }
    if (FreqStep > 0){
    if ((FreqStop - FreqStart)/FreqStep > 1000){
        int step = (FreqStop - FreqStart) / 1000 + 1;
        ui->spinBoxFreqStep->setValue(step);
        FreqStep = step;
    }}else{
        FreqStart = FreqStop;
        ui->spinBoxFreqStart->setValue(FreqStart);
        ui->spinBoxFreqStop->setValue(FreqStop);
    }
    */
}

void MainWindow::on_spinBoxFreqStep_editingFinished()
{
    data.setFreqStart(ui->spinBoxFreqStart->value());
    data.setFreqStop(ui->spinBoxFreqStop->value());
    data.setFreqStep(ui->spinBoxFreqStep->value());

    /*
    if (FreqStep > 0){
    if ((FreqStop - FreqStart)/FreqStep > 1000){
        int center = (((FreqStop - FreqStart)/2)+FreqStart);
        FreqStart = center - 500;
        FreqStop  = center + 500;
        ui->spinBoxFreqStart->setValue(FreqStart);
        ui->spinBoxFreqStop->setValue(FreqStop);

    }}else{
        FreqStart = FreqStop;
        ui->spinBoxFreqStart->setValue(FreqStart);
        ui->spinBoxFreqStop->setValue(FreqStop);
    }

    */

}

void MainWindow::on_spinBoxFreqStart_valueChanged(int arg1)
{
    on_spinBoxFreqStart_editingFinished();
}

void MainWindow::on_spinBoxFreqStop_valueChanged(int arg1)
{
    on_spinBoxFreqStop_editingFinished();
}

void MainWindow::on_spinBoxFreqStep_valueChanged(int arg1)
{
    on_spinBoxFreqStep_editingFinished();
}

void MainWindow::on_hS_Chanel0_valueChanged(int value)
{
    data.setValueDelim1(value);
}

void MainWindow::on_hS_Chanel1_valueChanged(int value)
{
    data.setValueDelim2(value);
}

void MainWindow::on_hS_Chanel2_valueChanged(int value)
{
    data.setValueDelim3(value);
}

void MainWindow::on_hS_Chanel3_valueChanged(int value)
{
    data.setValueDelim4(value);
}


void MainWindow::on_checkBoxC1_clicked()
{
    data.setChanelEnable1(ui->checkBoxC1->isChecked());
}

void MainWindow::on_checkBoxC2_clicked()
{
    data.setChanelEnable2(ui->checkBoxC2->isChecked());
}

void MainWindow::on_checkBoxC3_clicked()
{
    data.setChanelEnable3(ui->checkBoxC3->isChecked());
}

void MainWindow::on_checkBoxC4_clicked()
{
    data.setChanelEnable4(ui->checkBoxC4->isChecked());
}


void MainWindow::on_actionAFC_changed()
{
    ui->stackedWidget->setCurrentIndex(0);
}

void MainWindow::on_actionFreq_gen_changed()
{
    ui->stackedWidget->setCurrentIndex(1);
}

void MainWindow::on_actionAFC_hovered()
{
    ui->stackedWidget->setCurrentIndex(0);
}

void MainWindow::on_actionFreq_gen_hovered()
{
    ui->stackedWidget->setCurrentIndex(1);
    if (ui->pushButton->isChecked()){
        ui->pushButton->setChecked(false);
        on_pushButton_clicked();
    }
}
/*
#define BT_C        10
#define BT_LEFT     11
#define BT_RIGHT    12
#define BT_M        13
#define BT_MR       14
#define BT_PLUS     15
#define BT_MINUS    16
#define BT_DEL      17
#define BT_MUL      18
#define BT_ENTER    19
*/

void MainWindow::setFreq(uint key){
    if (key < 10){
    if ((data.getFreqGen()*10+key) >= 0 && (data.getFreqGen()*10+key) <= 50000000)
          data.setFreqGen(data.getFreqGen()*10+key);
    }else{
        switch (key) {
        case BT_C:
            data.setFreqGen(0);
            break;
        case BT_LEFT:
            if ((data.getFreqGen()-10) >= 0 && (data.getFreqGen()-10) <= 50000000)
                data.setFreqGen(data.getFreqGen()-10);
            break;
        case BT_RIGHT:
            if ((data.getFreqGen()+10) >= 0 && (data.getFreqGen()+10) <= 50000000)
                data.setFreqGen(data.getFreqGen()+10);
            break;
        case BT_M:
            FreqMem = data.getFreqGen();
            break;
        case BT_MR:
             data.setFreqGen(FreqMem);
            break;
        case BT_PLUS:
        case BT_MINUS:
        case BT_DEL:
        case BT_MUL:
             dig1 = data.getFreqGen();
             dig_key = key;
             data.setFreqGen(0);
            break;

        case BT_ENTER:
            switch (dig_key) {
            case BT_PLUS:
                data.setFreqGen(dig1 + data.getFreqGen());
                break;
            case BT_MINUS:
               data.setFreqGen(dig1 - data.getFreqGen());
                break;
            case BT_DEL:
                data.setFreqGen(dig1 / data.getFreqGen());
                break;
            case BT_MUL:
                data.setFreqGen(dig1 * data.getFreqGen());
                break;

            default:
                break;
            }
            dig_key = 0;
            break;
        default:
            break;
        }
    }

    if (dig_key > 0)
    {
        ui->pushButton_17->setEnabled(false);
        ui->pushButton_18->setEnabled(false);
        ui->pushButton_19->setEnabled(false);
        ui->pushButton_20->setEnabled(false);
    }else{
        ui->pushButton_17->setEnabled(true);
        ui->pushButton_18->setEnabled(true);
        ui->pushButton_19->setEnabled(true);
        ui->pushButton_20->setEnabled(true);
    }
    ui->lcdNumber->display(data.getFreqGen());

    if (ui->checkBoxOffSet->isChecked()){
        data.setFreqGen( data.getFreqGen() + ui->spinBoxOffSet->value());
    }
}

void MainWindow::on_pushButton_2_clicked()
{
    setFreq(7);
}

void MainWindow::on_pushButton_5_clicked()
{
    setFreq(8);
}

void MainWindow::on_pushButton_10_clicked()
{
   setFreq(9);
}

void MainWindow::on_pushButton_3_clicked()
{
    setFreq(4);
}

void MainWindow::on_pushButton_6_clicked()
{
    setFreq(5);
}

void MainWindow::on_pushButton_11_clicked()
{
    setFreq(6);
}


void MainWindow::on_pushButton_4_clicked()
{
    setFreq(1);
}

void MainWindow::on_pushButton_7_clicked()
{
    setFreq(2);
}

void MainWindow::on_pushButton_12_clicked()
{
    setFreq(3);
}

void MainWindow::on_pushButton_9_clicked()
{
    setFreq(0);
}

void MainWindow::on_pushButton_8_clicked()
{
     setFreq(BT_LEFT);
}

void MainWindow::on_pushButton_13_clicked()
{
     setFreq(BT_RIGHT);
}

void MainWindow::on_pushButton_14_clicked()
{
     setFreq(BT_C);
}

void MainWindow::on_pushButton_15_clicked()
{
     setFreq(BT_M);
}

void MainWindow::on_pushButton_16_clicked()
{
     setFreq(BT_MR);
}

void MainWindow::on_pushButton_17_clicked()
{
    setFreq(BT_PLUS);
}

void MainWindow::on_pushButton_18_clicked()
{
    setFreq(BT_MINUS);
}

void MainWindow::on_pushButton_19_clicked()
{
    setFreq(BT_DEL);
}

void MainWindow::on_pushButton_20_clicked()
{
    setFreq(BT_MUL);
}

void MainWindow::on_pushButton_21_clicked()
{
    setFreq(BT_ENTER);
}
