#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTimer>
#include <QVector>
#include <QThread>
#include "qcustomplot.h"
#include "hidapi.h"
#include "hidcontrol.h"
#include "exchangedata.h"


#define BT_C        10
#define BT_LEFT     11
#define BT_RIGHT    12
#define BT_M        13
#define BT_MR       14
#define BT_PLUS     15
#define BT_MINUS    16
#define BT_DEL      17
#define BT_MUL      18
#define BT_ENTER    19


namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

private slots:
    void on_pushButton_clicked();
    void timer_ticket_overflow();
    void timer_dev_ctr_overflow();

    void on_spinBoxFreqStart_editingFinished();

    void on_spinBoxFreqStop_editingFinished();

    void on_spinBoxFreqStep_editingFinished();

    void on_spinBoxFreqStart_valueChanged(int arg1);

    void on_spinBoxFreqStop_valueChanged(int arg1);

    void on_spinBoxFreqStep_valueChanged(int arg1);

    void on_hS_Chanel0_valueChanged(int value);

    void on_hS_Chanel1_valueChanged(int value);

    void on_hS_Chanel2_valueChanged(int value);

    void on_hS_Chanel3_valueChanged(int value);
    void on_checkBoxC1_clicked();

    void on_checkBoxC2_clicked();

    void on_checkBoxC3_clicked();

    void on_checkBoxC4_clicked();

    void on_actionAFC_changed();

    void on_actionFreq_gen_changed();

    void on_actionAFC_hovered();

    void on_actionFreq_gen_hovered();



    void on_pushButton_2_clicked();

    void on_pushButton_5_clicked();

    void on_pushButton_10_clicked();

    void on_pushButton_3_clicked();

    void on_pushButton_6_clicked();

    void on_pushButton_11_clicked();

    void on_pushButton_4_clicked();

    void on_pushButton_7_clicked();

    void on_pushButton_12_clicked();

    void on_pushButton_9_clicked();

    void on_pushButton_8_clicked();

    void on_pushButton_13_clicked();

    void on_pushButton_14_clicked();

    void on_pushButton_15_clicked();

    void on_pushButton_16_clicked();

    void on_pushButton_17_clicked();

    void on_pushButton_18_clicked();

    void on_pushButton_19_clicked();

    void on_pushButton_20_clicked();

    void on_pushButton_21_clicked();

public slots:


private:
    Ui::MainWindow *ui;
    QTimer *timer_ticket;
    QTimer *timer_device_control;

    QThread* thread_usb_data;
    QLabel statusBarText;
    QLabel statusBarFreq;

    QProgressBar progressBar;
    ExchangeData data;

    void replaceGraphTickX();

    double FreqMem;
    double dig1,did2;
    int dig_key;

    void setFreq(uint Key);


public:



};

#endif // MAINWINDOW_H
